import { VueNodeView } from './view';
import { VueNodeModel } from './model';
export var vueNodesMap = {};
export function register(config, lf) {
    var type = config.type, component = config.component, effect = config.effect, CustomNodeView = config.view, CustomNodeModel = config.model;
    if (!type) {
        throw new Error('You should specify type in config');
    }
    vueNodesMap[type] = {
        component: component,
        effect: effect,
    };
    lf.register({
        type: type,
        view: CustomNodeView || VueNodeView,
        model: CustomNodeModel || VueNodeModel,
    });
}
//# sourceMappingURL=registry.js.map