"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.register = exports.vueNodesMap = void 0;
var view_1 = require("./view");
var model_1 = require("./model");
exports.vueNodesMap = {};
function register(config, lf) {
    var type = config.type, component = config.component, effect = config.effect, CustomNodeView = config.view, CustomNodeModel = config.model;
    if (!type) {
        throw new Error('You should specify type in config');
    }
    exports.vueNodesMap[type] = {
        component: component,
        effect: effect,
    };
    lf.register({
        type: type,
        view: CustomNodeView || view_1.VueNodeView,
        model: CustomNodeModel || model_1.VueNodeModel,
    });
}
exports.register = register;
//# sourceMappingURL=registry.js.map